"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var MongoMigrateModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.MongoMigrateModule = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const changelog_lock_schema_1 = require("./schemas/changelog-lock.schema");
const changelog_schema_1 = require("./schemas/changelog.schema");
const migrate_service_1 = require("./services/migrate.service");
let MongoMigrateModule = MongoMigrateModule_1 = class MongoMigrateModule {
    static withMigrations(migrations, options) {
        return {
            module: MongoMigrateModule_1,
            imports: [
                mongoose_1.MongooseModule.forFeature([
                    {
                        name: changelog_schema_1.Changelog.name,
                        schema: changelog_schema_1.ChangelogSchema,
                        collection: options?.collectionName ?? 'changelog'
                    },
                    {
                        name: changelog_lock_schema_1.ChangelogLock.name,
                        schema: changelog_lock_schema_1.ChangelogLockSchema,
                        collection: options?.lockCollectionName ?? 'changelog-lock'
                    }
                ])
            ],
            providers: [
                {
                    provide: migrate_service_1.MigrateService.MIGRATIONS,
                    useValue: migrations,
                },
                migrate_service_1.MigrateService,
            ],
        };
    }
};
exports.MongoMigrateModule = MongoMigrateModule;
exports.MongoMigrateModule = MongoMigrateModule = MongoMigrateModule_1 = __decorate([
    (0, common_1.Module)({})
], MongoMigrateModule);
