/// <reference types="mongoose/types/aggregate" />
/// <reference types="mongoose/types/callback" />
/// <reference types="mongoose/types/collection" />
/// <reference types="mongoose/types/connection" />
/// <reference types="mongoose/types/cursor" />
/// <reference types="mongoose/types/document" />
/// <reference types="mongoose/types/error" />
/// <reference types="mongoose/types/expressions" />
/// <reference types="mongoose/types/helpers" />
/// <reference types="mongoose/types/middlewares" />
/// <reference types="mongoose/types/indexes" />
/// <reference types="mongoose/types/models" />
/// <reference types="mongoose/types/mongooseoptions" />
/// <reference types="mongoose/types/pipelinestage" />
/// <reference types="mongoose/types/populate" />
/// <reference types="mongoose/types/query" />
/// <reference types="mongoose/types/schemaoptions" />
/// <reference types="mongoose/types/schematypes" />
/// <reference types="mongoose/types/session" />
/// <reference types="mongoose/types/types" />
/// <reference types="mongoose/types/utility" />
/// <reference types="mongoose/types/validation" />
/// <reference types="mongoose/types/virtuals" />
/// <reference types="mongoose/types/inferschematype" />
import { MigrationWrapper } from "../types/migrations";
import { Logger } from "@nestjs/common";
import { Connection, Model } from "mongoose";
import { ChangelogLockDocument } from "../schemas/changelog-lock.schema";
import { ChangelogDocument } from "../schemas/changelog.schema";
/**
 * Used internally by the migration mechanism, for use only in `main.ts`.
 */
export declare class MigrateService {
    readonly connection: Connection;
    readonly migrations: MigrationWrapper[];
    private readonly changelogModel;
    private readonly changelogLockModel;
    static readonly MIGRATIONS = "MONGO_MIGRATIONS";
    readonly logger: Logger;
    constructor(connection: Connection, migrations: MigrationWrapper[], changelogModel: Model<ChangelogDocument>, changelogLockModel: Model<ChangelogLockDocument>);
    acquireLock(): Promise<boolean>;
    releaseLock(): Promise<boolean>;
    logMigration(migration: MigrationWrapper): Promise<void>;
    getChangelog(): Promise<ChangelogDocument[]>;
    private lockData;
}
